import React from 'react';
import type { BodyProps, CalendarContainerProps, CalendarProps, DayProps, NavigationProps, NextPrevProps, SelectProps, WeekdaysProps, WeekProps } from './Calendar.types';
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare function Body({ dueDateTime: dueDateTime_, displayDate: displayDate_, disabledDate, onSelect: onSelect_, selectedEnd: selectedEnd_, selectedStart: selectedStart_, ...props }: BodyProps): React.JSX.Element;
export declare namespace Body {
    var displayName: string;
}
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Container: React.ForwardRefExoticComponent<CalendarContainerProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Day: React.ForwardRefExoticComponent<DayProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Navigation: React.ForwardRefExoticComponent<NavigationProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Next: React.ForwardRefExoticComponent<NextPrevProps & React.RefAttributes<HTMLButtonElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Prev: React.ForwardRefExoticComponent<NextPrevProps & React.RefAttributes<HTMLButtonElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Week: React.ForwardRefExoticComponent<WeekProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Weekdays: React.ForwardRefExoticComponent<WeekdaysProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @parent Calendar
 * @deprecatedSince 11.6.0
 * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release,
 * please use the parent as a self closing tag.
 *
 * AFTER `<Calendar onSelect />`
 */
export declare const Select: React.ForwardRefExoticComponent<SelectProps & React.RefAttributes<HTMLDivElement>>;
export declare const Calendar_: React.ForwardRefExoticComponent<CalendarProps & React.RefAttributes<HTMLDivElement>>;
export declare const Calendar: React.ForwardRefExoticComponent<CalendarProps & React.RefAttributes<HTMLDivElement>> & {
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Body: typeof Body;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Container: React.ForwardRefExoticComponent<CalendarContainerProps & React.RefAttributes<HTMLDivElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Day: React.ForwardRefExoticComponent<DayProps & React.RefAttributes<HTMLDivElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Navigation: React.ForwardRefExoticComponent<NavigationProps & React.RefAttributes<HTMLDivElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Next: React.ForwardRefExoticComponent<NextPrevProps & React.RefAttributes<HTMLButtonElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Prev: React.ForwardRefExoticComponent<NextPrevProps & React.RefAttributes<HTMLButtonElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Select: React.ForwardRefExoticComponent<SelectProps & React.RefAttributes<HTMLDivElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Week: React.ForwardRefExoticComponent<WeekProps & React.RefAttributes<HTMLDivElement>>;
    /**
     * @deprecatedSince 11.6.0
     * @deprecated Subcomponents intended for internal library development. Export will be removed in a future release.
     *
    AFTER
    ```
      <Calendar onSelect />
    ```
    */
    Weekdays: React.ForwardRefExoticComponent<WeekdaysProps & React.RefAttributes<HTMLDivElement>>;
};
