import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { CardProps } from './Card.types';
/**

 We use cards to display information that is grouped together.
 Cards may contain rich media, text, buttons, and other functionality.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-card--demo)

 @see [Design Guidelines](https://design.procore.com/card)

 */
export declare const Card: React.ForwardRefExoticComponent<DivAttributes & CardProps & React.RefAttributes<HTMLDivElement>>;
