function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import { Help } from '@procore/core-icons';
import React from 'react';
import styled from 'styled-components';
import { Tooltip } from '../Tooltip';
import { useI18nContext } from '../_hooks/I18n';
import { colors } from '../_styles/colors';
import { getGapOutlineFocus } from '../_styles/mixins';
import { spacing } from '../_styles/spacing';
export var CheckboxTooltip = function CheckboxTooltip(props) {
  var I18n = useI18nContext();
  return /*#__PURE__*/React.createElement(Tooltip, _extends({
    role: "tooltip",
    trigger: ['hover', 'focus']
  }, props), /*#__PURE__*/React.createElement(StyledCheckboxTooltipIcon, {
    "aria-label": I18n.t('core.form.field.tooltipHelp'),
    "aria-hidden": false,
    size: "sm",
    tabIndex: 0
  }));
};
var StyledCheckboxTooltipIcon = /*#__PURE__*/styled(Help).withConfig({
  displayName: "StyledCheckboxTooltipIcon",
  componentId: "core-12_21_1__sc-1qa1ncf-0"
})(["margin-left:", "px;color:", ";vertical-align:middle;&:focus-visible{border-radius:50%;", " outline-offset:0;}"], spacing.sm, colors.gray45, getGapOutlineFocus);
//# sourceMappingURL=CheckboxTooltip.js.map