import React from 'react';
import type { CheckboxGroupState } from 'react-stately';
import type { CheckboxGroupProps } from './CheckboxGroup.types';
export declare const CheckboxGroupContext: React.Context<CheckboxGroupState | null>;
/**
 * Checkbox groups allow users to select multiple items from a list of options.
 *
 * Supported components: <NextTile role="checkbox">.
 *
 * @since 11.6.0
 */
export declare const CheckboxGroup: React.ForwardRefExoticComponent<CheckboxGroupProps & React.RefAttributes<HTMLDivElement>>;
