function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["disabled"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import { useCheckboxGroup } from '@react-aria/checkbox';
import React from 'react';
import { useCheckboxGroupState } from 'react-stately';
import { StyledLabel } from '../Form/Form.styles';
export var CheckboxGroupContext = /*#__PURE__*/React.createContext(null);

/**
 * Checkbox groups allow users to select multiple items from a list of options.
 *
 * Supported components: <NextTile role="checkbox">.
 *
 * @since 11.6.0
 */
export var CheckboxGroup = /*#__PURE__*/React.forwardRef(function CheckboxGroup(_ref, ref) {
  var disabled = _ref.disabled,
    props_ = _objectWithoutProperties(_ref, _excluded);
  var props = _objectSpread(_objectSpread({}, props_), {}, {
    isDisabled: disabled
  });
  var state = useCheckboxGroupState(props);
  var _useCheckboxGroup = useCheckboxGroup(props, state),
    groupProps = _useCheckboxGroup.groupProps,
    labelProps = _useCheckboxGroup.labelProps;
  return /*#__PURE__*/React.createElement("div", groupProps, props.label != null ? typeof props.label === 'string' ? /*#__PURE__*/React.createElement(StyledLabel, labelProps, props.label) : /*#__PURE__*/React.createElement("div", labelProps, props.label) : null, /*#__PURE__*/React.createElement(CheckboxGroupContext.Provider, {
    value: state
  }, props.children));
});
//# sourceMappingURL=CheckboxGroup.js.map