import React from 'react';
import type { Props } from '../_utils/types';
interface ClickOutsideProps extends Props {
    /**
     * @since 10.19.0
     */
    container?: any;
    /**
     * @since 10.19.0
     */
    containerClass?: string;
    /**
     * @since 10.19.0
     */
    onClickOutside?: (event: React.MouseEvent<Element, Event>) => any;
    /**
     * @since 10.19.0
     */
    tabIndex?: number;
}
/**
 * @deprecatedSince 11
 * @deprecated Intended for internal library development.
 */
export declare const ClickOutside: React.ForwardRefExoticComponent<ClickOutsideProps & React.RefAttributes<HTMLElement>>;
export {};
