var _excluded = ["children", "container", "containerClass", "onClickOutside"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { useEventListener } from '../_hooks/EventListener';
import { mergeRefs } from '../_utils/mergeRefs';
/**
 * @deprecatedSince 11
 * @deprecated Intended for internal library development.
 */
export var ClickOutside = /*#__PURE__*/React.forwardRef(function ClickOutside(_ref, ref) {
  var children = _ref.children,
    container = _ref.container,
    containerClass = _ref.containerClass,
    onClickOutside = _ref.onClickOutside,
    props = _objectWithoutProperties(_ref, _excluded);
  var Component = container || 'div';
  var scope = React.useRef(null);

  // need useCallback?
  var handler = function handler(event) {
    var current = scope.current;
    if (!current) {
      return;
    }
    onClickOutside && !current.contains(event.target) && onClickOutside(event);
  };
  var options = {
    capture: true
  };
  useEventListener({
    event: 'click',
    handler: handler,
    options: options
  });
  useEventListener({
    event: 'touchend',
    handler: handler,
    options: options
  });
  return /*#__PURE__*/React.createElement(Component, _extends({}, props, {
    className: containerClass,
    ref: mergeRefs(ref, scope)
  }), children);
});
ClickOutside.displayName = 'ClickOutside';
//# sourceMappingURL=ClickOutside.js.map