function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
import { Table } from '../../Table';
export var TableExample = function TableExample() {
  var _React$useState = React.useState('asc'),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    linkSortOrder = _React$useState2[0],
    setLinkSortingOrder = _React$useState2[1];
  var _React$useState3 = React.useState('asc'),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    nameSortOrder = _React$useState4[0],
    setNameSortOrder = _React$useState4[1];
  return /*#__PURE__*/React.createElement(Table.Container, null, /*#__PURE__*/React.createElement(Table, null, /*#__PURE__*/React.createElement(Table.Header, null, /*#__PURE__*/React.createElement(Table.HeaderRow, null, /*#__PURE__*/React.createElement(Table.HeaderCell, {
    snugfit: true
  }, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select All Rows"
  })), /*#__PURE__*/React.createElement(Table.HeaderCell, {
    sortOrder: linkSortOrder,
    onSortOrderChange: setLinkSortingOrder
  }, "Link"), /*#__PURE__*/React.createElement(Table.HeaderCell, {
    sortOrder: nameSortOrder,
    onSortOrderChange: setNameSortOrder,
    id: "header_name"
  }, "Name"), /*#__PURE__*/React.createElement(Table.HeaderCell, null, "Column Key"), /*#__PURE__*/React.createElement(Table.HeaderCell, null, "Percentages"), /*#__PURE__*/React.createElement(Table.HeaderCell, null, "Currency"))), /*#__PURE__*/React.createElement(Table.Body, null, /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))), /*#__PURE__*/React.createElement(Table.BodyRow, null, /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.Checkbox, {
    "aria-label": "Select Row"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.LinkCell, {
    href: "https://procore.github.io/core"
  }, "Link")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.TextAreaCell, {
    "aria-labelledby": "header_name",
    defaultValue: "Text area!",
    resizable: true
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.InputCell, {
    placeholder: "Placeholder"
  })), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.PercentCell, null, "5.00%")), /*#__PURE__*/React.createElement(Table.BodyCell, null, /*#__PURE__*/React.createElement(Table.CurrencyCell, null, "$21.00"))))));
};
//# sourceMappingURL=TableExample.js.map