import { flip, limitShift, offset, shift } from '@floating-ui/react-dom';
import { useOverlay } from '../Overlay/useOverlay';
export function useDropdownFlyoutOverlay(_ref) {
  var placement = _ref.placement,
    offsetConfig = _ref.offset;
  return useOverlay({
    placement: placement,
    middleware: [offset(offsetConfig), flip(), shift({
      limiter: limitShift()
    })]
  });
}
//# sourceMappingURL=useDropdownFlyoutOverlay.js.map