import type { DropzoneHookProps, DropzoneHookState } from './Dropzone.types';
/**
 * WARNING:
 * Use ACCEPT prop carefully, because mime type determination is not reliable across platforms.
 * Details: https://github.com/react-dropzone/react-dropzone/tree/master/examples/accept#browser-limitations
 */
export declare const useDropzone: ({ value, disabled, multiple, noClick, noKeyboard, onDragEnter, onDragOver, onDragLeave, onDropRejected, maxFileSize: maxSize, minFileSize: minSize, maxFileNumber, onDrop: _onDrop, onDropAccepted, ...props }?: DropzoneHookProps) => DropzoneHookState;
