var _excluded = ["children", "onClickOverlay", "open", "placement"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { Modal } from '../../Modal/Modal';
import { Portal } from '../../Portal/Portal';
import { useScrollLock } from '../../_hooks/ScrollLock';
import { StyledModalContainer, StyledModalOverlay } from './FileExplorer.styles';
function noop() {}
export var FileExplorerModal = /*#__PURE__*/React.forwardRef(function FileExplorerModal(_ref, ref) {
  var children = _ref.children,
    _ref$onClickOverlay = _ref.onClickOverlay,
    onClickOverlay = _ref$onClickOverlay === void 0 ? noop : _ref$onClickOverlay,
    _ref$open = _ref.open,
    open = _ref$open === void 0 ? false : _ref$open,
    _ref$placement = _ref.placement,
    placement = _ref$placement === void 0 ? 'center' : _ref$placement,
    props = _objectWithoutProperties(_ref, _excluded);
  useScrollLock(open);
  return /*#__PURE__*/React.createElement(Portal, {
    container: props.container
  }, /*#__PURE__*/React.createElement(StyledModalOverlay, {
    $open: open,
    ref: ref
  }, /*#__PURE__*/React.createElement(Modal.Scrim, {
    onClick: onClickOverlay
  }), /*#__PURE__*/React.createElement(StyledModalContainer, _extends({}, props, {
    placement: placement
  }), /*#__PURE__*/React.createElement(Modal.Content, null, children))));
});
//# sourceMappingURL=FileExplorerModal.js.map