import styled from 'styled-components';
import { Dropzone } from '../../Dropzone/Dropzone';
import { colors } from '../../_styles/colors';
import { spacing } from '../../_styles/spacing';
export var dropzoneContainerAttr = 'data-dropzone-container';
export var StyledDropzone = /*#__PURE__*/styled(Dropzone).withConfig({
  displayName: "StyledDropzone",
  componentId: "core-12_21_1__sc-ueh7d7-0"
})(["", ""], function (_ref) {
  var hidden = _ref.hidden;
  return hidden && "\n    [".concat(dropzoneContainerAttr, "] {\n      align-self: flex-start;\n      margin-bottom: ").concat(spacing.xs, "px;\n\n      &,\n      &:hover {\n        width: auto;\n        min-height: auto;\n        border: none;\n        padding: 0;\n        background: transparent;\n        cursor: default;\n      }\n    }\n  \n  ");
});
export var StyledDropzoneMessage = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledDropzoneMessage",
  componentId: "core-12_21_1__sc-ueh7d7-1"
})(["", ""], function (_ref2) {
  var error = _ref2.error;
  return error && "\n    color: ".concat(colors.gray15, ";\n  ");
});
export var StyledUploadButtonWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledUploadButtonWrapper",
  componentId: "core-12_21_1__sc-ueh7d7-2"
})(["display:block;margin-left:auto;margin-right:auto;margin-bottom:", "px;"], spacing.sm);
//# sourceMappingURL=FileSelectDropzone.styles.js.map