import styled from 'styled-components';
import { Dropzone, DropzoneErrorBanner } from '../../Dropzone/Dropzone';
import { colors } from '../../_styles/colors';
import { mediaIE11Hack } from '../../_styles/media';
import { spacing } from '../../_styles/spacing';
import { ThumbnailList } from '../ThumbnailList/ThumbnailList';
export var uploaderHeight = 411;
export var dropzoneHeight = 96;
export var errorBannerMarginTop = spacing.lg;
export var errorBannerMarginBottom = 3;
export var listMarginTop = spacing.sm;
export var listBorderWidth = 1;
var contentHeight = uploaderHeight + 2 * spacing.xl;
var dropzoneHeightWithIcon = 176;
var sourceWidth = 568;
export var StyledLocalSource = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledLocalSource",
  componentId: "core-12_21_1__sc-psqe8z-0"
})(["display:flex;flex-grow:1;flex-direction:column;align-items:stretch;height:", "px;max-height:", "px;padding:", "px ", "px ", "px ", "px;overflow-y:hidden;"], contentHeight, contentHeight, spacing.xl, spacing.xl + spacing.lg, spacing.xl, spacing.xl);
export var StyledDropzoneErrorBanner = /*#__PURE__*/styled(DropzoneErrorBanner).withConfig({
  displayName: "StyledDropzoneErrorBanner",
  componentId: "core-12_21_1__sc-psqe8z-1"
})(["margin-top:", "px;margin-bottom:", "px;margin-right:2px;"], errorBannerMarginTop, errorBannerMarginBottom);
export var StyledDropzoneWrapper = /*#__PURE__*/styled(Dropzone).withConfig({
  displayName: "StyledDropzoneWrapper",
  componentId: "core-12_21_1__sc-psqe8z-2"
})(["display:flex;height:auto;min-height:", "px;> div:first-child{display:flex;height:auto;}> ", "{display:none;}@media ", "{width:", "px;> div:first-child{height:100%;}}"], function (_ref) {
  var isIconVisible = _ref.isIconVisible;
  return isIconVisible ? dropzoneHeightWithIcon : dropzoneHeight;
}, DropzoneErrorBanner, mediaIE11Hack, sourceWidth);
export var StyledThumbnailList = /*#__PURE__*/styled(ThumbnailList).withConfig({
  displayName: "StyledThumbnailList",
  componentId: "core-12_21_1__sc-psqe8z-3"
})(["margin-top:", "px;border:", "px solid ", ";"], listMarginTop, listBorderWidth, colors.gray85);
//# sourceMappingURL=LocalSource.styles.js.map