import React from 'react';
import type { DivAttributes, Props } from '../../_utils/types';
export interface SourceItemProps extends Props {
    /**
     * @since 10.19.0
     */
    icon?: React.ReactNode;
    /**
     * @since 10.19.0
     */
    count?: number;
    /**
     * @since 10.19.0
     */
    countTruncationThreshold?: number;
    /**
     * @since 10.19.0
     */
    loading?: boolean;
    /**
     * @since 10.19.0
     */
    error?: boolean;
    /**
     * @since 10.19.0
     */
    selected?: boolean;
    /**
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * @since 10.19.0
     */
    focused?: boolean;
}
export declare const SourceItem: React.ForwardRefExoticComponent<DivAttributes & SourceItemProps & React.RefAttributes<HTMLDivElement>>;
