import type { TreeDefaultNode } from '../Tree/Tree.types';
export declare const MOCK_UPLOAD_FILES_URL = "/mock-upload-files";
export declare const MOCK_UPLOAD_WITH_ERRORS_FILES_URL = "/mock-upload-files-with-errors";
export declare const MOCK_BACKEND_LATENCY = 500;
export declare const useMockBackend: () => void;
export declare const gridItemsSample: ({
    id: string;
    name: string;
    src: any;
} | {
    id: string;
    name: string;
    src?: undefined;
})[];
export declare const groupedGridItemsSample: ({
    id: string;
    name: string;
    src: any;
    prostore_file_id: number;
    sourceId: string;
    groupId: string;
} | {
    id: string;
    name: string;
    prostore_file_id: number;
    sourceId: string;
    groupId: string;
    src?: undefined;
} | {
    id: string;
    name: string;
    prostore_file_id: number;
    sourceId: string;
    src?: undefined;
    groupId?: undefined;
})[];
export declare const photosCategories: {
    id: number;
    name: string;
}[];
export declare const photosByCategory: ({
    id: string;
    name: string;
    src: any;
    categoryId: number;
    label: string;
    prostore_file_id: number;
    sourceId: string;
} | {
    id: string;
    name: string;
    categoryId: number;
    label: string;
    prostore_file_id: number;
    sourceId: string;
    src?: undefined;
})[];
export declare const groupItemsSample: {
    id: string;
    title: string;
}[];
export declare const fileTreeSample: TreeDefaultNode[];
