function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React from 'react';
import { Tooltip } from '../Tooltip';
import { useI18nContext } from '../_hooks/I18n';
import { StyledFormFieldTooltipIcon } from './Form.styles';
export var FormFieldTooltip = function FormFieldTooltip(props) {
  var i18n = useI18nContext();
  return /*#__PURE__*/React.createElement(Tooltip, _extends({
    role: "tooltip",
    trigger: ['hover', 'focus']
  }, props), /*#__PURE__*/React.createElement(StyledFormFieldTooltipIcon, {
    "aria-label": i18n.t('core.form.field.tooltipHelp'),
    "aria-hidden": false,
    size: "sm",
    tabIndex: 0
  }));
};
//# sourceMappingURL=FormFieldTooltip.js.map