import styled, { keyframes } from 'styled-components';
import { spacing } from '../_styles/spacing';
var shimmerAnimation = /*#__PURE__*/keyframes(["0%{background-position:-1000px 500px;}100%{background-position:1000px 500px;}"]);
export var PlaceholderItem = /*#__PURE__*/styled.div.withConfig({
  displayName: "PlaceholderItem",
  componentId: "core-12_21_1__sc-1nja302-0"
})(["width:100%;min-height:24px;padding:10px 0;animation:", " 3s ease-out infinite;background:radial-gradient( ellipse at center,", " 0%,", " 50% );background-size:2000px 2000px;border-radius:", "px;"], shimmerAnimation, function (props) {
  return props.$startGradientColor;
}, function (props) {
  return props.$endGradientColor;
}, spacing.sm);
export var RoundPlaceholderItem = /*#__PURE__*/styled(PlaceholderItem).withConfig({
  displayName: "RoundPlaceholderItem",
  componentId: "core-12_21_1__sc-1nja302-1"
})(["width:", ";height:", ";border-radius:50%;"], function (props) {
  return props.$small ? '24px' : '40px';
}, function (props) {
  return props.$small ? '24px' : '40px';
});
//# sourceMappingURL=GhostPlaceholder.styles.js.map