import React from 'react';
import type { GridColProps, GridProps, GridRowProps } from './Grid.types';
declare function BaseGrid({ gutterX, gutterY, colStackCap, ...props }: GridProps): React.JSX.Element;
export declare const Grid: typeof BaseGrid & {
    Row: React.ForwardRefExoticComponent<GridRowProps & React.RefAttributes<HTMLDivElement>>;
    Col: React.ForwardRefExoticComponent<GridColProps & React.RefAttributes<HTMLDivElement>>;
};
export {};
