import type { AnchorAttributes, Props } from '../_utils/types';
declare type LinkVariant = 'gray' | 'white';
export interface LinkProps extends Props, AnchorAttributes {
    /**
     * The color variant of the link
     * @since 10.19.0
     *
     * @deprecated variant `gray` is deprecated and will be removed
     * @deprecatedSince 12.18.0
     */
    variant?: LinkVariant;
}
export {};
