var _excluded = ["children"],
  _excluded2 = ["children"],
  _excluded3 = ["children"],
  _excluded4 = ["children"],
  _excluded5 = ["children"],
  _excluded6 = ["children"],
  _excluded7 = ["alignRight", "block", "children", "search", "variant"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { addSubcomponents } from '../_utils/addSubcomponents';
import { StyledListPage, StyledListPageBanner, StyledListPageBody, StyledListPageBodyContent, StyledListPageContentControls, StyledListPageControl, StyledListPageMain, StyledListPageToolHeader } from './ListPage.styles';
export var ListPage_ = /*#__PURE__*/React.forwardRef(function ListPage(_ref, ref) {
  var children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledListPage, _extends({}, props, {
    ref: ref
  }), children);
});
export var Main = /*#__PURE__*/React.forwardRef(function Main(_ref2, ref) {
  var children = _ref2.children,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/React.createElement(StyledListPageMain, _extends({}, props, {
    ref: ref
  }), children);
});
export var Banner = /*#__PURE__*/React.forwardRef(function Banner(_ref3, ref) {
  var children = _ref3.children,
    props = _objectWithoutProperties(_ref3, _excluded3);
  return /*#__PURE__*/React.createElement(StyledListPageBanner, _extends({}, props, {
    ref: ref
  }), children);
});
export var ToolHeader = /*#__PURE__*/React.forwardRef(function ToolHeader(_ref4, ref) {
  var children = _ref4.children,
    props = _objectWithoutProperties(_ref4, _excluded4);
  return /*#__PURE__*/React.createElement(StyledListPageToolHeader, _extends({}, props, {
    ref: ref
  }), children);
});
export var ContentControls = /*#__PURE__*/React.forwardRef(function ContentControls(_ref5, ref) {
  var children = _ref5.children,
    props = _objectWithoutProperties(_ref5, _excluded5);
  return /*#__PURE__*/React.createElement(StyledListPageContentControls, _extends({}, props, {
    ref: ref
  }), children);
});
export var Body = /*#__PURE__*/React.forwardRef(function Body(_ref6, ref) {
  var children = _ref6.children,
    props = _objectWithoutProperties(_ref6, _excluded6);
  return /*#__PURE__*/React.createElement(StyledListPageBody, _extends({}, props, {
    ref: ref
  }), /*#__PURE__*/React.createElement(StyledListPageBodyContent, null, children));
});
export var Control = /*#__PURE__*/React.forwardRef(function Control(_ref7, ref) {
  var _ref7$alignRight = _ref7.alignRight,
    alignRight = _ref7$alignRight === void 0 ? false : _ref7$alignRight,
    _ref7$block = _ref7.block,
    block = _ref7$block === void 0 ? false : _ref7$block,
    children = _ref7.children,
    _ref7$search = _ref7.search,
    search = _ref7$search === void 0 ? false : _ref7$search,
    variant = _ref7.variant,
    props = _objectWithoutProperties(_ref7, _excluded7);
  return /*#__PURE__*/React.createElement(StyledListPageControl, _extends({}, props, {
    $alignRight: alignRight || variant === 'align-right',
    $block: block || variant === 'block',
    $search: search || variant === 'search',
    ref: ref
  }), children);
});
Banner.displayName = 'ListPage.Banner';
Body.displayName = 'ListPage.Body';
ContentControls.displayName = 'ListPage.ContentControls';
Control.displayName = 'ListPage.Control';
Main.displayName = 'ListPage.Main';
ToolHeader.displayName = 'ListPage.ToolHeader';

/**
 * @deprecated This `ListPage` layout is no longer supported and it is now recommended to use a `ToolLandingPage` layout instead.
 *
 * @deprecatedSince 12.9.0
 *
 * @see https://stories.core.procore.com/?path=/story/core-react_demos-toollandingpage--demo
 */
export var ListPage = addSubcomponents({
  Banner: Banner,
  Body: Body,
  ContentControls: ContentControls,
  Control: Control,
  Main: Main,
  ToolHeader: ToolHeader
}, ListPage_);
//# sourceMappingURL=ListPage.js.map