import styled, { css } from 'styled-components';
import { colors } from '../_styles/colors';
import { spacing } from '../_styles/spacing';
export var StyledListPageMain = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageMain",
  componentId: "core-12_21_1__sc-1eq7fzi-0"
})(["display:flex;flex:1 0 auto;flex-direction:column;min-width:0;padding:", "px ", "px;width:100%;"], spacing.lg, spacing.xl);
export var StyledListPageBanner = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageBanner",
  componentId: "core-12_21_1__sc-1eq7fzi-1"
})(["flex:0 0 auto;"]);
export var StyledListPageToolHeader = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageToolHeader",
  componentId: "core-12_21_1__sc-1eq7fzi-2"
})(["flex:0 0 auto;padding-bottom:", "px;"], spacing.lg);
export var StyledListPageControl = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageControl",
  componentId: "core-12_21_1__sc-1eq7fzi-3"
})(["flex:", ";", " ", ""], function (_ref) {
  var $block = _ref.$block;
  return $block ? '1 0 auto' : '0 0 auto';
}, function (_ref2) {
  var $alignRight = _ref2.$alignRight;
  if ($alignRight) {
    return css(["margin-left:auto;"]);
  }
}, function (_ref3) {
  var $search = _ref3.$search;
  if ($search) {
    return css(["width:240px;"]);
  }
});
export var StyledListPageContentControls = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageContentControls",
  componentId: "core-12_21_1__sc-1eq7fzi-4"
})(["align-items:center;display:flex;flex:0 0 auto;justify-content:space-between;padding:", "px 0;", " + ", "{margin-left:", "px;}"], spacing.md, StyledListPageControl, StyledListPageControl, spacing.lg);
export var StyledListPageBody = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageBody",
  componentId: "core-12_21_1__sc-1eq7fzi-5"
})(["display:flex;flex:1 0 auto;padding-top:", "px;"], spacing.md);
export var StyledListPageBodyContent = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPageBodyContent",
  componentId: "core-12_21_1__sc-1eq7fzi-6"
})(["flex:1 1 auto;"]);
export var StyledListPage = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledListPage",
  componentId: "core-12_21_1__sc-1eq7fzi-7"
})(["display:flex;flex-direction:row;height:100%;width:100%;", " + ", "{padding-top:", "px;}", " + ", "{border-top-color:", ";border-top-style:solid;border-top-width:1px;}", " + ", ",", " + ", "{border-top-color:", ";border-top-style:solid;border-top-width:1px;}", " + ", "{padding-top:0;}"], StyledListPageBanner, StyledListPageToolHeader, spacing.lg, StyledListPageContentControls, StyledListPageContentControls, colors.gray85, StyledListPageToolHeader, StyledListPageContentControls, StyledListPageToolHeader, StyledListPageBody, colors.gray85, StyledListPageContentControls, StyledListPageBody);
//# sourceMappingURL=ListPage.styles.js.map