var _excluded = ["value", "animated", "children"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { StyledGradient, StyledLoader } from './Loader.styles';
export var minProgressValue = 0;
export var maxProgressValue = 100;
export var clamp = function clamp(value) {
  var minValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : minProgressValue;
  var maxValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : maxProgressValue;
  return Math.max(minValue, Math.min(maxValue, Math.floor(value)));
};

/**
 * @deprecatedSince 11
 * @deprecated Intended for internal library development.
 */
export var Loader = function Loader(_ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? 0 : _ref$value,
    _ref$animated = _ref.animated,
    animated = _ref$animated === void 0 ? false : _ref$animated,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var progressValue = clamp(value);
  return /*#__PURE__*/React.createElement(StyledLoader, _extends({}, props, {
    style: {
      width: "".concat(progressValue, "%")
    }
  }), /*#__PURE__*/React.createElement(StyledGradient, {
    $animated: animated
  }, children));
};
Loader.displayName = 'Loader';
//# sourceMappingURL=Loader.js.map