import React from 'react';
import type { AnchorProps } from '../_hooks/Anchor';
export interface OverlayProps extends AnchorProps {
    /**
     * @since 10.19.0
     */
    shrinkOverlay?: boolean;
    /**
     * @since 10.19.0
     */
    container?: HTMLElement;
    arrow?: boolean;
}
/**
 * @deprecatedSince 11
 * @deprecated Intended for internal library development.
 */
export declare const Overlay: React.ForwardRefExoticComponent<OverlayProps & React.RefAttributes<HTMLElement>>;
