/// <reference types="react" />
export declare const StyledPageHeader: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("../../PageLayout").PageHeaderProps & import("react").RefAttributes<HTMLDivElement>>, any, {
    /** The container wants to have equal padding around it,
     * however some cases, like Tabs, do no want that padding. */
    $hasPaddingBottom: boolean;
}, never>;
export declare const StyledActions: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("../..").DivAttributes & import("../../Box").BoxProps & import("react").RefAttributes<HTMLDivElement>>, any, {}, never>;
export declare const StyledToggleActionBox: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("../..").DivAttributes & import("../../Box").BoxProps & import("react").RefAttributes<HTMLDivElement>>, any, {
    /** The toggle action adjusts the space underneath it.
     * Use this when the toggle action could overlap on some
     * content above it like actions or text. */
    $moveCloserToBottom?: boolean | undefined;
}, never>;
