import styled from 'styled-components';
import { Modal } from '../../Modal';
import { StyledModalContent } from '../../Modal/Modal.styles';
import { Page } from '../../PageLayout';
import { StyledAsideFluidContainer, StyledAsidePanel } from '../../PageLayout/PageLayout.styles';
import { mediaBreakpointsDown } from '../../PageLayout/PageLayout.utils';
import { StyledFooter as StyledPanelFooter } from '../../Panel/Panel.styles';
import { spacing } from '../../_styles/spacing';
var panelWidthSmall = 360;
export var mobileBreakpoint = 440;
export var StyledPageAside = /*#__PURE__*/styled(Page.Aside).withConfig({
  displayName: "StyledPageAside",
  componentId: "core-12_21_1__sc-1p7nu53-0"
})(["position:sticky;top:0;right:0;max-height:100vh;width:100%;height:100%;@media ", "{position:sticky;max-width:", "px;flex-basis:", "px;}", "{@media ", "{max-width:", "px;}}", "{position:sticky;top:0;right:0;box-shadow:none;animation:none;padding-bottom:68px;@media ", "{width:", "px;}@media (max-width:", "px){padding-bottom:0;}}", "{position:fixed;bottom:0;display:flex;width:100%;max-width:400px;@media ", "{max-width:", "px;}}"], mediaBreakpointsDown.tabletLg, panelWidthSmall, panelWidthSmall, StyledAsideFluidContainer, mediaBreakpointsDown.tabletLg, panelWidthSmall, StyledAsidePanel, mediaBreakpointsDown.tabletLg, panelWidthSmall, mobileBreakpoint, StyledPanelFooter, mediaBreakpointsDown.tabletLg, panelWidthSmall);
export var StyledModal = /*#__PURE__*/styled(Modal).withConfig({
  displayName: "StyledModal",
  componentId: "core-12_21_1__sc-1p7nu53-1"
})(["top:", "px;bottom:", "px;max-width:416px;transform:none;", "{max-height:100vh;}@media (max-width:", "px){top:0;bottom:0;left:0;right:0;max-width:100%;}"], spacing.md, spacing.md, StyledModalContent, mobileBreakpoint);
//# sourceMappingURL=PagePaneTemplate.styles.js.map