import styled from 'styled-components';
import { Page } from '../../PageLayout';
import { mediaBreakpointsDown } from '../../PageLayout/PageLayout.utils';
import { spacing } from '../../_styles/spacing';
export var mobileBreakpoint = 440;
export var StyledPageWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledPageWrapper",
  componentId: "core-12_21_1__sc-uuo7st-0"
})(["display:flex;flex-direction:column;"]);
export var StyledPageBodyWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledPageBodyWrapper",
  componentId: "core-12_21_1__sc-uuo7st-1"
})(["display:grid;grid-template-columns:1fr auto;"]);
export var StyledPageBody = /*#__PURE__*/styled(Page.Body).withConfig({
  displayName: "StyledPageBody",
  componentId: "core-12_21_1__sc-uuo7st-2"
})(["padding-bottom:", "px;@media ", "{padding:", "px;}"], spacing.lg, mediaBreakpointsDown.desktopMd, spacing.md);
//# sourceMappingURL=PageTemplate.styles.js.map