import { useContext } from 'react';
import { PageTemplateContext } from './PageTemplateContext';
export var usePageTemplateContext = function usePageTemplateContext() {
  var context = useContext(PageTemplateContext);
  if (!context) {
    throw new Error('usePageTemplateContext must be used within a PageTemplateProvider');
  }
  return context;
};
//# sourceMappingURL=usePageTemplateContext.js.map