import styled, { css } from 'styled-components';
import { Pill } from '../Pill/Pill';
import { colors } from '../_styles/colors';
import { getEllipsis } from '../_styles/mixins';
import { spacing } from '../_styles/spacing';
var checkedIconPlaceholderWidth = 32;
export var PillSelectOptionWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "PillSelectOptionWrapper",
  componentId: "core-12_21_1__sc-1ai2ze0-0"
})(["display:flex;align-items:center;justify-content:space-between;"]);
export var PillSelectCheckedContainer = /*#__PURE__*/styled.div.withConfig({
  displayName: "PillSelectCheckedContainer",
  componentId: "core-12_21_1__sc-1ai2ze0-1"
})(["align-items:center;color:", ";display:inline-flex;padding-left:", "px;width:", "px;"], colors.blue50, spacing.sm, checkedIconPlaceholderWidth);
export var PillSelectLabel = /*#__PURE__*/styled(Pill).withConfig({
  displayName: "PillSelectLabel",
  componentId: "core-12_21_1__sc-1ai2ze0-2"
})(["", ""], getEllipsis);
export var PillSelectLabelWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "PillSelectLabelWrapper",
  componentId: "core-12_21_1__sc-1ai2ze0-3"
})(["display:flex;max-width:100%;pointer-events:auto;", ""], function (_ref) {
  var disabled = _ref.disabled;
  return disabled && css(["pointer-events:none;"]);
});
//# sourceMappingURL=PillSelect.styles.js.map