var _excluded = ["children", "className", "error", "style"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { StyledRadioButton, StyledRadioButtonInput, StyledRadioButtonLabel } from './RadioButton.styles';
/**

 We use radio buttons to allow users to select a single, exclusive option from
 a list of multiple options.

 To present options in a dropdown, use a single select.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-radiobutton--demo)

 @see [Design Guidelines](https://design.procore.com/radio-button)

 */
export var RadioButton = /*#__PURE__*/React.forwardRef(function RadioButton(_ref, ref) {
  var children = _ref.children,
    className = _ref.className,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? false : _ref$error,
    style = _ref.style,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledRadioButton, {
    className: className,
    style: style,
    $children: children,
    $error: error
  }, /*#__PURE__*/React.createElement(StyledRadioButtonInput, _extends({
    "aria-invalid": !error ? undefined : true,
    type: "radio",
    ref: ref
  }, props)), /*#__PURE__*/React.createElement(StyledRadioButtonLabel, null, children));
});
RadioButton.displayName = 'RadioButton';
//# sourceMappingURL=RadioButton.js.map