import type { Props } from '../_utils/types';
export interface RadioButtonProps extends Props {
    /**
     * Selected state of the radio button
     * @since 10.19.0
     */
    checked?: boolean;
    /**
     * Disabled state of the radio button
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * Error state of the radio button
     * @since 10.19.0
     */
    error?: boolean;
}
