import React from 'react';
import type { HeadingProps } from '../Semantic/Semantic.types';
import type { SectionProps, SectionProviderProps } from './Section.types';
export declare const LevelContext: React.Context<number>;
export declare function Heading({ level: level_, ...props }: HeadingProps & {
    level?: number;
}): React.JSX.Element;
export declare const SectionProvider: ({ children }: SectionProviderProps) => React.JSX.Element;
/**
 * @deprecatedSince 11
 * @deprecated Intended for internal library development. See Panel.Section or DetailPage.Section
 */
export declare const Section: React.ForwardRefExoticComponent<SectionProps & React.RefAttributes<HTMLDivElement>>;
