import type { DetailPageProps } from '../DetailPage/DetailPage.types';
import type { PageFooterProps } from '../PageLayout/PageLayout.types';
export interface SettingsPageProps extends DetailPageProps {
}
export interface SettingsPageFooterProps extends PageFooterProps {
    /**
     * When a Settings Page has no unsaved changes, the footer can be hidden.
     * See `Form.SettingsPageFooter` for automatic connection to `Form`.
     */
    visible: boolean;
}
