import React from 'react';
import type { SettingsPageFooterTemplateProps, SettingsPageHeaderTemplateProps } from './SettingsPageTemplate.types';
export declare const SettingsPageHeaderTemplate: React.ForwardRefExoticComponent<Required<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "heading" | "breadcrumbs">> & Partial<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "banner" | "pills" | "actions" | "subheading" | "tabs">> & React.RefAttributes<HTMLDivElement>>;
export declare const SettingsPageFooterTemplate: React.ForwardRefExoticComponent<Required<Pick<import("../PageTemplate/PageFooterTemplate").PageFooterTemplateProps, "actions">> & Partial<Pick<import("../PageTemplate/PageFooterTemplate").PageFooterTemplateProps, "required" | "notation">> & React.RefAttributes<HTMLDivElement>>;
export declare const SettingsPageTemplate: React.ForwardRefExoticComponent<Pick<import("../PageTemplate/PageTemplate").PageTemplateProps, "children" | "footer" | "header"> & {
    headerProps?: SettingsPageHeaderTemplateProps | undefined;
    footerProps?: SettingsPageFooterTemplateProps | undefined;
    hasNavigation?: boolean | undefined;
} & React.RefAttributes<HTMLDivElement>>;
