/// <reference types="react" />
declare type TabStyleProps = {
    $selected?: boolean;
    $dark?: boolean;
};
export declare const StyledOverlay: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("..").DivAttributes & import("../Card").CardProps & import("react").RefAttributes<HTMLDivElement>>, any, {}, never>;
export declare const StyledTabList: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare const StyledTabs: import("styled-components").StyledComponent<"nav", any, {
    $dark?: boolean | undefined;
    index?: number | undefined;
}, never>;
/**
 * Switches between different Tab styles of traditional and helix header navigation.
 * Allows separate style CSS without conditionals across all the components.
 * @returns Subcomponents to render
 */
export declare function getStyledComponents(helixHeader?: boolean): {
    Tab: import("styled-components").StyledComponent<"div", any, TabStyleProps, never>;
    TabInner: import("styled-components").StyledComponent<"div", any, TabStyleProps, never>;
    Link: import("styled-components").StyledComponent<"span", any, {}, never>;
    DropdownTab: import("styled-components").StyledComponent<"div", any, TabStyleProps, never>;
    DropdownTabInner: import("styled-components").StyledComponent<"div", any, TabStyleProps, never>;
};
export {};
