/// <reference types="react" />
import type { Placement } from './Tearsheet.types';
export declare const animationSpeed: {
    disabled: number;
    tearsheet: number;
    scrim: number;
    closeButton: number;
};
export declare const StyledTearsheetContent: import("styled-components").StyledComponent<"div", any, {
    $placement: Placement;
    $open: boolean;
    $opening?: boolean | undefined;
    $closing?: boolean | undefined;
}, never>;
export declare const minScrimSize: number;
export declare const StyledTearsheetBody: import("styled-components").StyledComponent<"div", any, {
    $block: boolean;
    $placement: Placement;
    $stretch: boolean;
}, never>;
export declare const StyledScrimContainer: import("styled-components").StyledComponent<"div", any, {
    $placement: Placement;
}, never>;
export declare const StyledButtonContainer: import("styled-components").StyledComponent<"div", any, {
    $placement: Placement;
}, never>;
export declare const StyledButtonCard: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("..").DivAttributes & import("..").CardProps & import("react").RefAttributes<HTMLDivElement>>, any, {
    $open: boolean;
    $opening?: boolean | undefined;
    $closing?: boolean | undefined;
}, never>;
