import type { AnimationPhase, AnimationStatus } from './Tearsheet.types';
export declare const wait: (ms: number) => Promise<unknown>;
export declare function getScrimClassName(status: AnimationStatus, phase: AnimationPhase): "fade-in" | "fade-out" | undefined;
export declare function getAnimationState(targetPhase: AnimationPhase, currentPhase: AnimationPhase, status: AnimationStatus): {
    $open: boolean;
    $opening?: boolean;
    $closing?: boolean;
};
