import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { TextEditorOutputProps } from './TextEditorOutput.types';
/**

 We use TextEditorOutput to render formatted text.

 @since 10.24.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-texteditoroutput--demo)

 */
export declare const TextEditorOutput: React.ForwardRefExoticComponent<TextEditorOutputProps & DivAttributes & React.RefAttributes<HTMLDivElement>>;
