import React from 'react';
export declare type ThumbnailDocumentIconVariant = 'image' | 'unknown' | 'zip' | 'drawing' | 'email' | 'excel' | 'gantt' | 'ini' | 'mov' | 'pdf' | 'powerpoint' | 'word' | 'xml' | '3d' | 'folder' | 'folderPeople' | 'folderLock' | 'file';
export interface DocumentIconProps {
    variant: ThumbnailDocumentIconVariant;
    className?: string;
    width?: string | number;
    height?: string | number;
    focusable?: boolean;
}
export declare function DocumentIcon({ className, focusable, height, variant, width, }: DocumentIconProps): React.JSX.Element;
