import { VariableSizeGrid } from 'react-window';
import styled from 'styled-components';
import { Checkbox } from '../Checkbox';
import { Thumbnail } from '../Thumbnail';
import { Typography } from '../Typography/Typography';
import { getEllipsis } from '../_styles/mixins';
import { spacing } from '../_styles/spacing';
export var StyledCheckbox = /*#__PURE__*/styled(Checkbox).withConfig({
  displayName: "StyledCheckbox",
  componentId: "core-12_21_1__sc-1inrbm9-0"
})(["input{z-index:2;}"]);
export var StyledGroupCell = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledGroupCell",
  componentId: "core-12_21_1__sc-1inrbm9-1"
})(["display:flex;align-items:flex-end;padding-bottom:", "px;"], spacing.md);
export var StyledThumbnail = /*#__PURE__*/styled(Thumbnail).withConfig({
  displayName: "StyledThumbnail",
  componentId: "core-12_21_1__sc-1inrbm9-2"
})(["display:inline-flex;&:focus{outline:none;}"]);
// VariableSizeGrid has provided width and height as inline style, so to make it flexible and support responsive !important was added
export var StyledVariableSizeGrid = /*#__PURE__*/styled(VariableSizeGrid).withConfig({
  displayName: "StyledVariableSizeGrid",
  componentId: "core-12_21_1__sc-1inrbm9-3"
})(["height:100% !important;& > div{width:100% !important;}"]);
export var StyledGroupTitle = /*#__PURE__*/styled(Typography).withConfig({
  displayName: "StyledGroupTitle",
  componentId: "core-12_21_1__sc-1inrbm9-4"
})(["", ""], getEllipsis);
export var StyledSpinnerWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledSpinnerWrapper",
  componentId: "core-12_21_1__sc-1inrbm9-5"
})(["display:flex;justify-content:center;align-items:center;width:100%;height:100%;"]);
export var StyledThumbnailGrid = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledThumbnailGrid",
  componentId: "core-12_21_1__sc-1inrbm9-6"
})(["display:flex;flex-wrap:wrap;outline:none;"]);
//# sourceMappingURL=ThumbnailGrid.styles.js.map