import React from 'react';
import type { Props } from '../_utils/types';
import type { HeroMediaProps, HeroTextProps, InteractableTileProps, LinkTileProps, SelectableTileProps, TileProps } from './Tile.types';
export declare const InteractableTile: React.ForwardRefExoticComponent<Omit<InteractableTileProps, "variant"> & React.RefAttributes<HTMLDivElement>>;
export declare const LinkTile: React.ForwardRefExoticComponent<Omit<LinkTileProps, "variant"> & React.RefAttributes<HTMLAnchorElement>>;
export declare const SelectableTile: React.ForwardRefExoticComponent<Omit<SelectableTileProps, "variant"> & React.RefAttributes<HTMLDivElement>>;
export declare const Tile: React.ForwardRefExoticComponent<TileProps & React.RefAttributes<HTMLElement>> & {
    Actions: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Content: React.ForwardRefExoticComponent<HeroTextProps & React.RefAttributes<HTMLDivElement>>;
    Footer: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    HeroText: React.ForwardRefExoticComponent<HeroTextProps & React.RefAttributes<HTMLDivElement>>;
    HeroMedia: React.ForwardRefExoticComponent<HeroMediaProps & React.RefAttributes<HTMLDivElement>>;
};
