/// <reference types="react" />
import type { TileCommonProps } from './Tile.types';
interface StyledTile {
    $orientation: TileCommonProps['orientation'];
}
export declare const StyledLinkTile: import("styled-components").StyledComponent<"a", any, StyledTile, never>;
export declare const StyledSelectableTile: import("styled-components").StyledComponent<"div", any, StyledTile & {
    $selected: boolean;
    $disabled?: boolean | undefined;
    $focused?: boolean | undefined;
}, never>;
export declare const StyledInteractableTile: import("styled-components").StyledComponent<"div", any, StyledTile, never>;
export declare const StyledFooter: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare const StyledTileContent: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("..").DivAttributes & import("..").BoxProps & import("react").RefAttributes<HTMLDivElement>>, any, {}, never>;
export declare const StyledHeroMedia: import("styled-components").StyledComponent<"figure", any, {
    $orientation: TileCommonProps['orientation'];
}, never>;
export declare const StyledHeroOverlay: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare const StyledHeroText: import("styled-components").StyledComponent<"div", any, {
    $orientation: TileCommonProps['orientation'];
}, never>;
export {};
