import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { TitleAssetsProps, TitleProps } from './Title.types';
export declare const Title: React.ForwardRefExoticComponent<TitleProps & React.RefAttributes<HTMLDivElement>> & {
    Pills: React.ForwardRefExoticComponent<DivAttributes & React.RefAttributes<HTMLDivElement>>;
    Text: React.ForwardRefExoticComponent<DivAttributes & React.RefAttributes<HTMLDivElement>>;
    Subtext: React.ForwardRefExoticComponent<DivAttributes & React.RefAttributes<HTMLDivElement>>;
    Actions: React.ForwardRefExoticComponent<DivAttributes & React.RefAttributes<HTMLDivElement>>;
    Assets: React.ForwardRefExoticComponent<DivAttributes & TitleAssetsProps & React.RefAttributes<HTMLDivElement>>;
};
