import styled from 'styled-components';
import { Button } from '../Button';
import { getTypographyIntent, typographyWeights } from '../Typography/Typography.styles';
import { borderRadius } from '../_styles/borderRadius';
import { colors } from '../_styles/colors';
import { getShadow } from '../_styles/shadows';
import { spacing } from '../_styles/spacing';
export var StyledToast = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledToast",
  componentId: "core-12_21_1__sc-1l6lk2n-0"
})(["", " align-items:center;background-color:", ";border-radius:", "px;color:", ";display:flex;min-height:48px;padding:", "px ", "px;width:550px;"], getShadow(4, 'bottom'), function (_ref) {
  var $variant = _ref.$variant;
  return $variant === 'success' ? colors.green30 : colors.red50;
}, borderRadius.md, colors.white, spacing.md, spacing.xl);

// $legacy is direct string inside Toast. Next is with subcomponents
export var StyledToastText = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledToastText",
  componentId: "core-12_21_1__sc-1l6lk2n-1"
})(["", " font-weight:", ";overflow:hidden;", ""], getTypographyIntent('body'), typographyWeights.semibold, function (_ref2) {
  var $legacy = _ref2.$legacy;
  return $legacy ? "margin-left: ".concat(spacing.lg, "px;") : "padding: 0 ".concat(spacing.lg, "px;");
});
export var StyledToastButton = /*#__PURE__*/styled(Button).withConfig({
  displayName: "StyledToastButton",
  componentId: "core-12_21_1__sc-1l6lk2n-2"
})(["line-height:0;color:", ";padding:0;margin-left:auto;"], colors.white);
//# sourceMappingURL=Toast.styles.js.map