import type { DetailPageProps } from '../DetailPage';
import type { Props } from '../_utils/types';
export interface ToolLandingPageProps extends Omit<DetailPageProps, 'width' | 'hasNavigation'> {
}
export interface ToolLandingPageTitleProps extends Props {
    /**
     * Link for the settings page
     * @since 12.9.0
     */
    settingsHref?: string;
}
