var _excluded = ["settingsLink"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import { Cog } from '@procore/core-icons';
import React from 'react';
import { LinkButton } from '../Button';
import { PageHeaderTemplate } from '../PageTemplate/PageHeaderTemplate';
import { PageTemplate } from '../PageTemplate/PageTemplate';
import { Tooltip } from '../Tooltip';
import { useI18nContext } from '../_hooks/I18n';
export var ToolLandingPageHeaderTemplate = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var settingsLink = _ref.settingsLink,
    headerProps = _objectWithoutProperties(_ref, _excluded);
  var i18n = useI18nContext();
  var settingsLinkIsString = typeof settingsLink === 'string';
  var settingsButton = settingsLink ? /*#__PURE__*/React.createElement(Tooltip, {
    overlay: i18n.t('core.toolHeader.settingsAction'),
    trigger: ['hover', 'focus']
  }, /*#__PURE__*/React.createElement(LinkButton, {
    "aria-label": i18n.t('core.toolHeader.settingsAction'),
    as: settingsLinkIsString ? undefined : settingsLink,
    href: settingsLinkIsString ? settingsLink : '#',
    icon: /*#__PURE__*/React.createElement(Cog, null),
    role: "link",
    variant: "secondary"
  })) : null;
  return /*#__PURE__*/React.createElement(PageHeaderTemplate, _extends({
    ref: ref,
    beforeTitleZone: settingsButton
  }, headerProps, {
    "data-core-react": "tool-landing-page-header-template"
  }));
});
export var ToolLandingPageTemplate = /*#__PURE__*/React.forwardRef(function (_ref2, ref) {
  var children = _ref2.children,
    header = _ref2.header,
    headerProps = _ref2.headerProps;
  return /*#__PURE__*/React.createElement(PageTemplate, {
    "data-core-react": "tool-landing-page-template",
    header: header !== null && header !== void 0 ? header : /*#__PURE__*/React.createElement(ToolLandingPageHeaderTemplate, headerProps),
    ref: ref
  }, children);
});
//# sourceMappingURL=ToolLandingPageTemplate.js.map