import type { TimerApi } from './Timer';
export declare type BeforeResult = Promise<any> | boolean | undefined | void;
export declare type BeforeCallback = (event: Event) => BeforeResult;
interface DelayedCallbackConfig {
    after?: (event: Event) => void;
    before?: BeforeCallback;
    delay: number;
    timer?: TimerApi;
}
/**
 * @deprecatedSince 9
 * @deprecated Never officially documented/supported
 */
export declare function isPromise(obj: any): obj is Promise<any>;
/**
 * @deprecatedSince 9
 * @deprecated Never officially documented/supported
 */
export declare function wrapPromise(result: BeforeResult): Promise<any>;
/**
 * @deprecatedSince 9
 * @deprecated Never officially documented/supported
 */
export declare function useDelayedCallback({ after, before, delay, timer, }: DelayedCallbackConfig): (event: any) => Promise<false | void>;
export {};
