import React from 'react';
interface InjectedScriptConfig {
    id: string;
    src: string;
}
interface InjectedScriptApi {
    isLoaded: boolean;
    setLoaded: (isLoaded: boolean) => void;
}
interface RenderProps extends InjectedScriptConfig {
    children?: ((props: InjectedScriptApi) => React.ReactNode) | null;
}
/**
 * @deprecatedSince 11
 * @deprecated Not a concern of the Design System. See source to duplicate https://github.com/procore/core/blob/%40procore/core-react%4010.30.0/packages/core-react/src/state/InjectedScript.tsx#L25
 */
export declare function useInjectedScript({ id, src }: InjectedScriptConfig): {
    isLoaded: boolean;
    setLoaded: React.Dispatch<React.SetStateAction<boolean>>;
};
/**
 * @deprecatedSince 11
 * @deprecated Not a concern of the Design System. See source to duplicate https://github.com/procore/core/blob/%40procore/core-react%4010.30.0/packages/core-react/src/state/InjectedScript.tsx#L25
 */
export declare function InjectedScript({ children, ...props }: RenderProps): React.ReactNode;
export {};
