declare const dateTimePresets: {
    time: Intl.DateTimeFormatOptions;
    'abbr-weekday-abbr-date': Intl.DateTimeFormatOptions;
    date: Intl.DateTimeFormatOptions;
    'weekday-date': Intl.DateTimeFormatOptions;
    none: Intl.DateTimeFormatOptions;
    'numeric-date': Intl.DateTimeFormatOptions;
};
export declare type IntlDateTimeOptionPresets = keyof typeof dateTimePresets;
export declare const getPresetDateTimeOptions: (type: IntlDateTimeOptionPresets) => Intl.DateTimeFormatOptions;
export declare function intlDateTimeFormat(locale: string, options?: Intl.DateTimeFormatOptions): {
    format: (date: Date) => string;
    formatToParts: (date: Date) => Intl.DateTimeFormatPart[];
    resolvedOptions: () => Intl.ResolvedDateTimeFormatOptions;
};
export declare function toDate(date: string | Date, log?: string): Date;
export declare function formatMachineDate(date: Date): string;
export {};
