import * as React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { BoxProps } from './Box.types';
/**
 * `Box` is a general layout utility for CSS properties like `display`, `text-align`,
 * flex, spacing, and layout properties.
 */
export declare const Box: React.ForwardRefExoticComponent<DivAttributes & BoxProps & React.RefAttributes<HTMLDivElement>>;
