import type { AriaCheckboxGroupProps } from '@react-aria/checkbox';
import type React from 'react';
export interface CheckboxGroupProps extends Omit<AriaCheckboxGroupProps, 'isDisabled'> {
    /**
     * @since 11.6.0
     */
    children: React.ReactNode;
    /**
     * @since 11.6.0
     */
    disabled?: boolean;
}
