import React from 'react';
import type { DetailPageHeaderTemplateProps } from './DetailPageTemplate.types';
export declare const DetailPageHeaderTemplate: React.ForwardRefExoticComponent<Required<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "heading" | "breadcrumbs">> & Partial<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "banner" | "pills" | "actions" | "subheading" | "tabs" | "toggleAction">> & React.RefAttributes<HTMLDivElement>>;
export declare const DetailPageFooterTemplate: React.ForwardRefExoticComponent<Required<Pick<import("../PageTemplate/PageFooterTemplate").PageFooterTemplateProps, "actions">> & Partial<Pick<import("../PageTemplate/PageFooterTemplate").PageFooterTemplateProps, "required" | "notation">> & React.RefAttributes<HTMLDivElement>>;
export declare const DetailPageTemplate: React.ForwardRefExoticComponent<Pick<import("../PageTemplate/PageTemplate").PageTemplateProps, "children" | "footer" | "header" | "pane"> & {
    headerProps?: DetailPageHeaderTemplateProps | undefined;
    footerProps?: import("../PageTemplate/PageFooterTemplate").PageFooterTemplateProps | undefined;
    hasNavigation?: boolean | undefined;
} & React.RefAttributes<HTMLDivElement>>;
