var _excluded = ["header", "headerProps", "children", "footer", "footerProps", "hasNavigation"];
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React from 'react';
import { PageBodyNavigation } from '../PageLayout/PageLayout';
import { PageFooterTemplate } from '../PageTemplate/PageFooterTemplate';
import { PageHeaderTemplate } from '../PageTemplate/PageHeaderTemplate';
import { PageTemplate } from '../PageTemplate/PageTemplate';
export var DetailPageHeaderTemplate = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(PageHeaderTemplate, _extends({
    ref: ref
  }, props, {
    "data-core-react": "detail-page-header-template"
  }));
});
export var DetailPageFooterTemplate = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(PageFooterTemplate, _extends({
    ref: ref
  }, props, {
    "data-core-react": "detail-page-footer-template"
  }));
});
export var DetailPageTemplate = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var header = _ref.header,
    headerProps = _ref.headerProps,
    children = _ref.children,
    footer = _ref.footer,
    footerProps = _ref.footerProps,
    hasNavigation = _ref.hasNavigation,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(PageTemplate, _extends({
    "data-core-react": "detail-page-template",
    header: header !== null && header !== void 0 ? header : /*#__PURE__*/React.createElement(DetailPageHeaderTemplate, headerProps),
    footer: footer !== null && footer !== void 0 ? footer : /*#__PURE__*/React.createElement(DetailPageFooterTemplate, _extends({}, footerProps, {
      actions: footerProps === null || footerProps === void 0 ? void 0 : footerProps.actions
    })),
    innerPane: hasNavigation && /*#__PURE__*/React.createElement(PageBodyNavigation, {
      minSections: 3
    })
  }, props, {
    ref: ref
  }), children);
});
//# sourceMappingURL=DetailPageTemplate.js.map