import styled from 'styled-components';
import { getTypographyIntent } from '../Typography/Typography.styles';
import { arrowRight } from '../_styles/arrows';
import { colors } from '../_styles/colors';
import { getEllipsis } from '../_styles/mixins';
import { spacing } from '../_styles/spacing';
export var StyledDropdownFlyout = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledDropdownFlyout",
  componentId: "core-12_21_1__sc-1i79jsg-0"
})(["display:flex;flex-wrap:wrap;flex-direction:column;width:100%;max-height:855px;padding:", "px 0;"], spacing.sm);
export var StyledDropdownFlyoutItem = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledDropdownFlyoutItem",
  componentId: "core-12_21_1__sc-1i79jsg-1"
})(["display:flex;justify-content:space-between;cursor:pointer;width:100%;padding:", "px ", "px;color:", ";", " &[data-highlighted='true'],&:hover{background-color:", ";}"], spacing.xs, spacing.lg, colors.gray20, getTypographyIntent('body'), colors.gray96);
export var StyledDropdownFlyoutLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledDropdownFlyoutLabel",
  componentId: "core-12_21_1__sc-1i79jsg-2"
})(["", ""], getEllipsis());
export var StyledDropdownFlyoutExpandIcon = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledDropdownFlyoutExpandIcon",
  componentId: "core-12_21_1__sc-1i79jsg-3"
})(["position:relative;display:inline-flex;align-self:center;flex-shrink:0;margin-left:", "px;white-space:nowrap;", ""], spacing.lg, arrowRight(4, 'black'));
//# sourceMappingURL=DropdownFlyout.styles.js.map