import type { CSSProperties } from 'react';
import type { OverlayOffsetValue, OverlayRefType, ReferenceRefType } from '../Overlay/useOverlay';
import type { Placement } from '../_utils/placement';
export declare function useDropdownFlyoutOverlay({ placement, offset: offsetConfig, }: {
    placement: Placement;
    offset?: OverlayOffsetValue;
}): {
    overlayRef: OverlayRefType;
    referenceRef: ReferenceRefType;
    overlayStyle: CSSProperties;
};
