var _excluded = ["error"];
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import { Error } from '@procore/core-icons';
import React from 'react';
import { P } from '../Semantic';
import { Typography } from '../Typography';
import { colors } from '../_styles/colors';
import { addSubcomponents } from '../_utils/addSubcomponents';
import { StyledFieldFooter } from './Field.styles';
import { StyledField, StyledFieldHeader } from './Field.styles';
export var Field_ = /*#__PURE__*/React.forwardRef(function Field(props, ref) {
  return /*#__PURE__*/React.createElement(StyledField, _extends({}, props, {
    ref: ref
  }));
});
export var FieldHeader = /*#__PURE__*/React.forwardRef(function Field(props, ref) {
  return /*#__PURE__*/React.createElement(StyledFieldHeader, _extends({}, props, {
    ref: ref
  }));
});
export var FieldFooter = /*#__PURE__*/React.forwardRef(function FieldFooter(_ref, ref) {
  var error = _ref.error,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledFieldFooter, null, error ? /*#__PURE__*/React.createElement(P, _extends({}, props, {
    ref: ref
  }), /*#__PURE__*/React.createElement(Error, {
    style: {
      color: colors.red50
    }
  }), typeof error !== 'boolean' ? /*#__PURE__*/React.createElement(Typography, {
    color: "red50"
  }, error) : null) : props.children);
});
Field_.displayName = 'Field';
FieldHeader.displayName = 'Field.Header';
FieldFooter.displayName = 'Field.Footer';
export var Field = addSubcomponents({
  Header: FieldHeader,
  Footer: FieldFooter
}, Field_);
//# sourceMappingURL=Field.js.map