import type { ValueId } from '../FileSelect.types';
export interface FileTokenEntry {
    /**
     * @since 10.19.0
     */
    id: string | number;
    /**
     * @since 10.19.0
     */
    name: string;
    /**
     * @since 10.19.0
     */
    error?: string;
    /**
     * @since 10.19.0
     */
    progress?: number;
}
export interface QaTags {
    /**
     * @since 10.19.0
     */
    fileToken?: (id: ValueId) => string;
    /**
     * @since 10.19.0
     */
    closeButton?: string;
}
export interface FileTokenListProps {
    /**
     * @since 10.19.0
     */
    tokens: FileTokenEntry[];
    /**
     * @since 10.19.0
     */
    onClick?: (token: FileTokenEntry) => void;
    /**
     * @since 10.19.0
     */
    onClose?: (token: FileTokenEntry) => void;
    /**
     * @since 10.19.0
     */
    qa?: QaTags;
}
