import type { ValueId } from '../FileSelect.types';
import type { ThumbnailListItem } from '../ThumbnailList/ThumbnailList.types';
export interface ProgressAnnouncerProps {
    /**
     * @since 11.7.1
     */
    items: ThumbnailListItem[];
    /**
     * @since 11.7.1
     */
    throttleMs?: number;
    /**
     * @since 11.7.1
     */
    uploadProgress: Record<ValueId, number | null>;
}
