import type { Props } from '../_utils/types';
interface QaTags {
    /**
     * @since 10.19.0
     */
    closeButton?: string;
}
export interface FileTokenProps extends Props {
    /**
     * @since 10.19.0
     */
    fileName: string;
    /**
     * @since 10.19.0
     */
    progressValue?: number;
    /**
     * @since 10.19.0
     */
    errorMessage?: string;
    /**
     * @since 10.19.0
     */
    onLabelClick?: () => void;
    /**
     * @since 10.19.0
     */
    onClose?: () => void;
    /**
     * @since 10.19.0
     */
    qa?: QaTags;
}
export {};
