import React from 'react';
import type { ButtonAttributes, DivAttributes, Props, SpanAttributes } from '../_utils/types';
import type { FilterTokenProps } from './FilterToken.types';
export declare const FilterToken: React.ForwardRefExoticComponent<DivAttributes & FilterTokenProps & React.RefAttributes<HTMLDivElement>> & {
    Label: React.ForwardRefExoticComponent<SpanAttributes & Props & React.RefAttributes<HTMLSpanElement>>;
    Remove: React.ForwardRefExoticComponent<ButtonAttributes & Props & React.RefAttributes<HTMLButtonElement>>;
};
