import styled, { css } from 'styled-components';
import { getButtonStyles } from '../Button/Button.styles';
import { getTypographyIntent, semiboldRules } from '../Typography/Typography.styles';
import { colors } from '../_styles/colors';
import { getEllipsis, getFocus } from '../_styles/mixins';
import { spacing } from '../_styles/spacing';
export var StyledLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledLabel",
  componentId: "core-12_21_1__sc-1l1h29r-0"
})(["", " ", " ", " flex:0 1 auto;"], getTypographyIntent('body'), getEllipsis, semiboldRules);
export var StyledFilterToken = /*#__PURE__*/styled.div.withConfig({
  displayName: "StyledFilterToken",
  componentId: "core-12_21_1__sc-1l1h29r-1"
})(["align-items:center;background-color:", ";border-radius:4px;border:1px solid transparent;color:", ";cursor:default;display:inline-flex;height:36px;justify-content:space-between;line-height:1;max-width:360px;min-width:48px;padding:", "px ", "px;&:hover,&.hover{background-color:", ";}", ""], colors.blue96, colors.blue45, spacing.sm, spacing.md, colors.blue90, function (_ref) {
  var _ref$$focused = _ref.$focused,
    $focused = _ref$$focused === void 0 ? false : _ref$$focused;
  return $focused && css(["", " background-color:", ";border-color:", " border-width:2px;"], getFocus(), colors.blue96, colors.blue40);
});
export var StyledFilterRemoveButton = /*#__PURE__*/styled.button.withConfig({
  displayName: "StyledFilterRemoveButton",
  componentId: "core-12_21_1__sc-1l1h29r-2"
})(["", " ", ";background:transparent;color:", ";&:active,&:focus,&:hover{background:", ";color:", ";}&:disabled{pointer-events:none;user-select:none;}&:disabled,&[aria-disabled='true']{background:transparent;color:", ";}height:24px;margin:0 0 0 6px;padding:0 ", "px;[data-icon-prop='true']{pointer-events:none;height:16px;width:16px;}"], function (_ref2) {
  var $disabled = _ref2.$disabled;
  return getButtonStyles(false, $disabled, false, 'sm', 'tertiary');
}, getTypographyIntent('small'), colors.blue45, colors.white, colors.blue45, colors.blue45, spacing.xs);
export var StyledContent = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledContent",
  componentId: "core-12_21_1__sc-1l1h29r-3"
})(["align-items:center;display:flex;overflow:hidden;"]);
export var StyledContentLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "StyledContentLabel",
  componentId: "core-12_21_1__sc-1l1h29r-4"
})(["overflow:hidden;padding:0 6px;text-overflow:ellipsis;white-space:nowrap;& + span{padding-left:0;}"]);
//# sourceMappingURL=FilterToken.styles.js.map