import React from 'react';
import type { InputAttributes } from '../_utils/types';
import type { InputProps } from './Input.types';
/**

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-input--demo)

 @see [Design Guidelines](https://design.procore.com/text-input)

 */
export declare const Input: React.ForwardRefExoticComponent<InputAttributes & InputProps & React.RefAttributes<HTMLInputElement>>;
