import type { InputAttributes } from '../_utils/types';
export interface InputProps extends InputAttributes {
    /**
     * Controls the error state of the `Input`, changing the
     * background color and border colors to red
     * @since 10.19.0
     */
    error?: boolean;
    /**
     * @deprecated Use the `error` prop instead
     * @deprecatedSince 11
     * @since 10.19.0
     */
    variant?: 'error' | '';
}
