import React from 'react';
import type { Props } from '../_utils/types';
import type { ListPageControlProps, ListPageProps } from './ListPage.types';
export declare const ListPage_: React.ForwardRefExoticComponent<ListPageProps & React.RefAttributes<HTMLDivElement>>;
export declare const Main: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const Banner: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const ToolHeader: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const ContentControls: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const Body: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const Control: React.ForwardRefExoticComponent<ListPageControlProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @deprecated This `ListPage` layout is no longer supported and it is now recommended to use a `ToolLandingPage` layout instead.
 *
 * @deprecatedSince 12.9.0
 *
 * @see https://stories.core.procore.com/?path=/story/core-react_demos-toollandingpage--demo
 */
export declare const ListPage: React.ForwardRefExoticComponent<ListPageProps & React.RefAttributes<HTMLDivElement>> & {
    Banner: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Body: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    ContentControls: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Control: React.ForwardRefExoticComponent<ListPageControlProps & React.RefAttributes<HTMLDivElement>>;
    Main: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    ToolHeader: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
};
