/**
 * Small Sample Size: Planets */
export declare const planets: {
    name: string;
    groupId: string;
}[];
export declare const planetGroups: {
    name: string;
    id: string;
}[];
/**
 *  Medium Sample Size: Vegetable-like */
declare type VegBiology = 'fruit' | 'fungus' | 'berry';
declare type VegGroups = {
    biology?: VegBiology;
    id: number;
    name: string;
};
export declare const veggieGroups: VegGroups[];
declare type Veg = {
    aka?: string[];
    biology?: VegBiology;
    category: number;
    name: string;
};
/**
 * @see https://simple.wikipedia.org/wiki/List_of_vegetables
 */
export declare const veggies: Veg[];
export declare const getALotOfVeggies: (times?: number) => Veg[];
export {};
