import type { Props } from '../_utils/types';
export declare const notationVariant: {
    readonly error: "error";
    readonly none: "";
    readonly pagination: "pagination";
    readonly required: "required";
};
declare type NotationVariant = (typeof notationVariant)[keyof typeof notationVariant];
export interface NotationProps extends Props {
    /**
     * The notation color variant
     * @since 10.19.0
     */
    variant?: NotationVariant;
}
export {};
