import type { InputValue, UseNumberFormatConfig } from './NumberInput.types';
export declare function usePrevious<T>(value: T): T;
export declare function useNumberFormat({ decimalScale: _decimalScale, fillDecimalScale, locale: _locale, }: UseNumberFormatConfig): {
    formatValue: (value: InputValue) => string;
    getValueLengthInfo: (value: InputValue, isNumericString?: any) => {
        length: number;
        safeLength: number;
        isSafeLength: boolean;
        safelyTruncatedValue: string;
        integerLength: number;
        safeIntegerLength: number;
        isSafeIntegerLength: boolean;
        fractionLength: number;
        safeFractionLength: number;
        isSafeFractionLength: boolean;
    };
    locale: string[];
    fixedDecimalScale: boolean;
    fillDecimalScaleOnBlur: boolean;
    decimalScale: number;
};
