export declare const mediaBreakpointsDown: {
    tabletMd: string;
    tabletLg: string;
    desktopMd: string;
};
export declare const getIsUsingSmallScreen: () => boolean;
export declare const wait: (ms: number) => Promise<void>;
export declare function getBottomOffsetForFooterUseCase(footerEl: HTMLDivElement, globalBottomOffset: number): number | null;
export declare function getGlobalBottomOffset(containerEl: HTMLDivElement): number;
export declare function getGlobalTopOffset(containerEl: HTMLDivElement): number;
export declare function getRightOffset(containerEl: HTMLDivElement): number;
export declare function getIsIntersectingVertically(upperEl: HTMLElement, lowerEl: HTMLElement): boolean;
