var _excluded = ["actions", "notation", "required"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { Box } from '../../Box';
import { Required } from '../../Required';
import { Typography } from '../../Typography';
import { StyledPageFooter } from './PageFooterTemplate.styles';
export var PageFooterTemplate = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var actions = _ref.actions,
    notation = _ref.notation,
    required = _ref.required,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledPageFooter, _extends({
    ref: ref,
    "data-core-react": "page-footer-template"
  }, props), /*#__PURE__*/React.createElement(Box, {
    display: "flex",
    flexDirection: "column",
    gap: "xs"
  }, required && /*#__PURE__*/React.createElement(Required, {
    showLabel: true
  }, typeof required === 'string' ? required : null), notation && /*#__PURE__*/React.createElement(Typography, {
    color: "gray15",
    intent: "small"
  }, notation)), /*#__PURE__*/React.createElement(Box, {
    display: "flex",
    gap: "sm"
  }, actions));
});
//# sourceMappingURL=PageFooterTemplate.js.map