var _excluded = ["navigationLabel"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import { useId } from '@react-aria/utils';
import React from 'react';
import { useAnchorNavigationContext } from '../../AnchorNavigation/AnchorNavigationProvider';
import { Card } from '../../Card';
import { SectionProvider } from '../../Section';
import { mergeRefs } from '../../_utils/mergeRefs';
export var PageTemplateCard = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var navigationLabel = _ref.navigationLabel,
    props = _objectWithoutProperties(_ref, _excluded);
  var cardId = useId();
  var cardRef = React.useRef(null);
  var _useAnchorNavigationC = useAnchorNavigationContext(),
    registerSection = _useAnchorNavigationC.registerSection,
    unregisterSection = _useAnchorNavigationC.unregisterSection;
  var id = props.id || cardId;
  React.useEffect(function () {
    var _cardRef$current, _cardRef$current$quer;
    var label = navigationLabel || ((_cardRef$current = cardRef.current) === null || _cardRef$current === void 0 ? void 0 : (_cardRef$current$quer = _cardRef$current.querySelector('h2')) === null || _cardRef$current$quer === void 0 ? void 0 : _cardRef$current$quer.textContent);
    if (!cardRef.current || !label) return;
    registerSection(id, label, cardRef.current);
    return function () {
      return unregisterSection(id);
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  return /*#__PURE__*/React.createElement(SectionProvider, null, /*#__PURE__*/React.createElement(Card, _extends({
    ref: mergeRefs(ref, cardRef),
    id: id
  }, props)));
});
//# sourceMappingURL=PageTemplateCard.js.map