import React from 'react';
import type { PillProps } from './Pill.types';
/**

 Pills are used to highlight important information in a list or form such as
 a status.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-pill--demo)

 @see [Design Guidelines](https://design.procore.com/pill)

 */
export declare const Pill: React.ForwardRefExoticComponent<PillProps & React.RefAttributes<HTMLSpanElement>>;
