import type React from 'react';
import type { HeadingAttributes } from '../_utils/types';
export interface HeadingProps extends HeadingAttributes {
    /**
     * Change the HTML tag.
     * @since 11.12.0
     */
    as?: 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6';
}
export interface ListProps extends React.HTMLAttributes<HTMLUListElement | HTMLOListElement> {
    /** @since 11.25.1 */
    listStyleType?: string;
}
