function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React from 'react';
import { PageBodyNavigation } from '../PageLayout/PageLayout';
import { PageFooterTemplate } from '../PageTemplate/PageFooterTemplate';
import { PageHeaderTemplate } from '../PageTemplate/PageHeaderTemplate';
import { PageTemplate } from '../PageTemplate/PageTemplate';
export var SettingsPageHeaderTemplate = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(PageHeaderTemplate, _extends({
    ref: ref
  }, props, {
    "data-core-react": "settings-page-header-template"
  }));
});
export var SettingsPageFooterTemplate = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(PageFooterTemplate, _extends({
    ref: ref
  }, props, {
    "data-core-react": "settings-page-footer-template"
  }));
});
export var SettingsPageTemplate = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
    footer = _ref.footer,
    footerProps = _ref.footerProps,
    hasNavigation = _ref.hasNavigation,
    header = _ref.header,
    headerProps = _ref.headerProps;
  return /*#__PURE__*/React.createElement(PageTemplate, {
    "data-core-react": "settings-page-template",
    header: header !== null && header !== void 0 ? header : /*#__PURE__*/React.createElement(SettingsPageHeaderTemplate, headerProps),
    footer: footer !== null && footer !== void 0 ? footer : /*#__PURE__*/React.createElement(SettingsPageFooterTemplate, _extends({}, footerProps, {
      actions: footerProps === null || footerProps === void 0 ? void 0 : footerProps.actions
    })),
    innerPane: hasNavigation && /*#__PURE__*/React.createElement(PageBodyNavigation, {
      minSections: 3
    }),
    ref: ref
  }, children);
});
//# sourceMappingURL=SettingsPageTemplate.js.map