import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { SuperSelectMenuItemProps } from './SuperSelect.types';
export declare const Overlay: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<HTMLElement>>;
export declare const SingleTrigger: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const MultiTrigger: (props: React.PropsWithChildren<any>) => React.JSX.Element | null;
export declare const TriggerContainer: React.ForwardRefExoticComponent<any> | React.FC<any>;
export declare const Trigger: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<HTMLDivElement>>;
export declare const Indicators: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Label: React.ForwardRefExoticComponent<{
    hoverable: boolean;
} & React.RefAttributes<HTMLDivElement>>;
export declare const Loading: () => React.JSX.Element;
export declare const ArrowContainer: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Arrow: ({ up, down, left, right, width, height, border, }: any) => React.JSX.Element;
export declare const Clear: () => React.JSX.Element;
export declare const MultiInputContainer: (props: React.PropsWithChildren<{}>) => React.JSX.Element;
export declare const MultiInput: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
export declare const MultiValue: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const MultiValueContainer: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const SearchContainer: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
export declare const Search: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Header: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Footer: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
export declare const EmptyMessage: (props: any) => React.JSX.Element;
export declare const Options: (props: React.PropsWithChildren<{}> & DivAttributes) => React.JSX.Element;
export declare const Group: (props: React.PropsWithChildren<{}>) => React.JSX.Element;
export declare const Item: React.ForwardRefExoticComponent<SuperSelectMenuItemProps & React.RefAttributes<HTMLDivElement>>;
export declare const OptionGroupHeader: ({ optgroup }: any) => React.JSX.Element;
export declare const OptionLabel: ({ option }: any) => React.JSX.Element;
export declare const OptionContent: ({ option }: any) => React.JSX.Element;
export declare const DraggableOptionContent: ({ index, option }: any) => React.JSX.Element;
export declare const DragHandle: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const CheckboxContainer: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Checkbox: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const CheckmarkContainer: (props: React.PropsWithChildren<any>) => React.JSX.Element;
export declare const Checkmark: (props: React.PropsWithChildren<any>) => React.JSX.Element;
