var _excluded = ["resize"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { StyledTextArea } from './TextArea.styles';
/**

 Text areas give our users space to input unformatted text. All text areas are
 manually expandable by dragging the bottom right corner to the desired size.

 If users need to add formatted text, see Text Editor.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-textarea--demo)

 @see [Design Guidelines](https://design.procore.com/text-area)

 */
export var TextArea = /*#__PURE__*/React.forwardRef(function TextArea(_ref, ref) {
  var _ref$resize = _ref.resize,
    resize = _ref$resize === void 0 ? 'both' : _ref$resize,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledTextArea, _extends({
    resize: resize
  }, props, {
    ref: ref
  }));
});
TextArea.displayName = 'TextArea';
//# sourceMappingURL=TextArea.js.map