function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
import { StyledImageThumbnailPreview } from './Thumbnail.styles';
export function ThumbnailPreview(_ref) {
  var file = _ref.file;
  var _React$useState = React.useState(''),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    fileUrl = _React$useState2[0],
    setFileUrl = _React$useState2[1];
  React.useEffect(function () {
    var _URL$createObjectURL, _URL$createObjectURL2, _URL;
    if (!file) {
      setFileUrl('');
      return;
    }
    setFileUrl(((_URL$createObjectURL = (_URL$createObjectURL2 = (_URL = URL).createObjectURL) === null || _URL$createObjectURL2 === void 0 ? void 0 : _URL$createObjectURL2.call(_URL, file)) !== null && _URL$createObjectURL !== void 0 ? _URL$createObjectURL : '').toString());
  }, [file]);
  React.useEffect(function () {
    return function () {
      if (fileUrl) {
        var _URL$revokeObjectURL, _URL2;
        (_URL$revokeObjectURL = (_URL2 = URL).revokeObjectURL) === null || _URL$revokeObjectURL === void 0 ? void 0 : _URL$revokeObjectURL.call(_URL2, fileUrl);
      }
    };
  }, [fileUrl]);
  return fileUrl ? /*#__PURE__*/React.createElement(StyledImageThumbnailPreview, {
    $bgImage: fileUrl
  }) : null;
}
//# sourceMappingURL=ThumbnailPreview.js.map