import styled, { css } from 'styled-components';
import { Breadcrumbs } from '../Breadcrumbs/Breadcrumbs';
import { Button } from '../Button/Button';
import { Card } from '../Card/Card';
import { Flex } from '../Flex/Flex';
import { MenuImperative } from '../MenuImperative/MenuImperative';
import { Spinner } from '../Spinner/Spinner';
import { colors } from '../_styles/colors';
import { spacing } from '../_styles/spacing';
export var StyledTieredSelect = /*#__PURE__*/styled(MenuImperative).withConfig({
  displayName: "StyledTieredSelect",
  componentId: "core-12_21_1__sc-e1ql06-0"
})(["align-items:stretch;max-height:40vh;"]);
export var StyledTieredSelectIcon = /*#__PURE__*/styled(Flex).withConfig({
  displayName: "StyledTieredSelectIcon",
  componentId: "core-12_21_1__sc-e1ql06-1"
})(["height:24px;width:24px;"]);
export var StyledTieredSelectArrowButton = /*#__PURE__*/styled(Button).withConfig({
  displayName: "StyledTieredSelectArrowButton",
  componentId: "core-12_21_1__sc-e1ql06-2"
})(["border:1px solid transparent;"]);
export var StyledTieredSelectBreadcrumbs = /*#__PURE__*/styled(Breadcrumbs).withConfig({
  displayName: "StyledTieredSelectBreadcrumbs",
  componentId: "core-12_21_1__sc-e1ql06-3"
})(["background-color:", ";flex-wrap:wrap;margin-top:", "px;max-height:68px;overflow-y:auto;padding:", "px ", "px;", ""], colors.gray96, spacing.sm, spacing.xs, spacing.md, function (_ref) {
  var $nonInteractive = _ref.$nonInteractive;
  if ($nonInteractive) {
    return css(["margin-top:", "px;pointer-events:none;"], spacing.md);
  }
});
export var StyledTieredSelectHome = /*#__PURE__*/styled(Flex).withConfig({
  displayName: "StyledTieredSelectHome",
  componentId: "core-12_21_1__sc-e1ql06-4"
})(["height:20px;"]);
export var StyledTieredSelectOption = /*#__PURE__*/styled(MenuImperative.Item).withConfig({
  displayName: "StyledTieredSelectOption",
  componentId: "core-12_21_1__sc-e1ql06-5"
})(["align-items:center;display:flex;justify-content:space-between;padding:2px ", "px;"], spacing.lg);
export var StyledTieredSelectLoadingMore = /*#__PURE__*/styled(Flex).withConfig({
  displayName: "StyledTieredSelectLoadingMore",
  componentId: "core-12_21_1__sc-e1ql06-6"
})(["align-items:center;justify-content:center;padding:", "px ", "px 0px ", "px;"], spacing.xs, spacing.lg, spacing.lg);
export var StyledTieredSelectOverlay = /*#__PURE__*/styled(Card).withConfig({
  displayName: "StyledTieredSelectOverlay",
  componentId: "core-12_21_1__sc-e1ql06-7"
})(["max-width:248px;min-width:inherit;"]);
export var StyledTieredSelectSpinnerOverlay = /*#__PURE__*/styled(Spinner).withConfig({
  displayName: "StyledTieredSelectSpinnerOverlay",
  componentId: "core-12_21_1__sc-e1ql06-8"
})(["min-height:auto;"]);
//# sourceMappingURL=TieredSelect.styles.js.map