var _excluded = ["aria-label", "href", "children"],
  _excluded2 = ["aria-label", "children"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { StyledAnchor, StyledUnstyledButton } from '../Semantic/Semantic.styles';
import { Tooltip } from '../Tooltip/Tooltip';
var ActionIconLink = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var label = _ref['aria-label'],
    href = _ref.href,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(Tooltip, {
    overlay: label,
    trigger: ['hover', 'focus']
  }, /*#__PURE__*/React.createElement(StyledAnchor, _extends({
    "aria-label": label,
    href: href
  }, props, {
    ref: ref
  }), children));
});
var ActionIconButton = /*#__PURE__*/React.forwardRef(function (_ref2, ref) {
  var label = _ref2['aria-label'],
    children = _ref2.children,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/React.createElement(Tooltip, {
    overlay: label,
    trigger: ['hover', 'focus']
  }, /*#__PURE__*/React.createElement(StyledUnstyledButton, _extends({
    "aria-label": label
  }, props, {
    ref: ref
  }), children));
});
function ActionIconInner(props, ref) {
  if (props.role === 'link' || props.href) {
    return /*#__PURE__*/React.createElement(ActionIconLink, _extends({}, props, {
      ref: ref
    }));
  }
  if (props.role === 'button') {
    return /*#__PURE__*/React.createElement(ActionIconButton, _extends({}, props, {
      ref: ref
    }));
  }
  return /*#__PURE__*/React.createElement(ActionIconButton, _extends({}, props, {
    ref: ref
  }));
}
export var ActionIcon = /*#__PURE__*/React.forwardRef(ActionIconInner);
//# sourceMappingURL=ActionIcon.js.map