function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["className", "icon"],
  _excluded2 = ["children", "className"],
  _excluded3 = ["children", "variant"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import { Cog } from '@procore/core-icons';
import React from 'react';
import { Tabs as TabsBase } from '../Tabs/Tabs';
import { useI18nContext } from '../_hooks/I18n';
import { addSubcomponents } from '../_utils/addSubcomponents';
import { ActionIcon } from './ActionIcon';
import { StyledHeaderActions, StyledHeaderBadge, StyledHeaderTabs, StyledToolHeader, StyledToolHeaderIconContainer, StyledToolHeaderTitle } from './ToolHeader.styles';
var ToolHeader_ = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(StyledToolHeader, _extends({
    ref: ref
  }, props));
});
export var Icon = /*#__PURE__*/React.forwardRef(function Icon(_ref, ref) {
  var className = _ref.className,
    icon_ = _ref.icon,
    props = _objectWithoutProperties(_ref, _excluded);
  var icon = icon_ ? /*#__PURE__*/React.cloneElement(icon_, _objectSpread(_objectSpread({}, props), {}, {
    size: 'sm'
  })) : /*#__PURE__*/React.createElement(Cog, _extends({}, props, {
    size: "sm"
  }));
  return /*#__PURE__*/React.createElement(StyledToolHeaderIconContainer, {
    className: className,
    ref: ref
  }, icon);
});
function SettingsActionInner(props, ref) {
  var i18n = useI18nContext();
  var Comp = ActionIcon;
  return /*#__PURE__*/React.createElement(Comp, _extends({
    "aria-label": i18n.t('core.toolHeader.settingsAction'),
    ref: ref
  }, props), /*#__PURE__*/React.createElement(ToolHeader.Icon, null));
}
var SettingsAction = /*#__PURE__*/React.forwardRef(SettingsActionInner);
export var Title = StyledToolHeaderTitle;
export var Tabs = /*#__PURE__*/React.forwardRef(function Tabs(_ref2, ref) {
  var children = _ref2.children,
    className = _ref2.className,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/React.createElement(StyledHeaderTabs, {
    className: className,
    ref: ref
  }, /*#__PURE__*/React.createElement(TabsBase, props, children));
});
export var Actions = StyledHeaderActions;

/**
 * @deprecated
 *
 * This `Badge` pattern is no longer supported and it is now recommended to use a `Pill` instead.
 *
 * @deprecatedSince 10.20.0
 *
 * @see https://core.procore.com/latest/web/components/pill/react/
 */
export var Badge = /*#__PURE__*/React.forwardRef(function Badge(_ref3, ref) {
  var children = _ref3.children,
    variant = _ref3.variant,
    props = _objectWithoutProperties(_ref3, _excluded3);
  return /*#__PURE__*/React.createElement(StyledHeaderBadge, _extends({}, props, {
    $variant: variant,
    ref: ref
  }), children);
});
ToolHeader_.displayName = 'ToolHeader';
Icon.displayName = 'ToolHeader.Icon';
Title.displayName = 'ToolHeader.Title';
Tabs.displayName = 'ToolHeader.Tabs';
Actions.displayName = 'ToolHeader.Actions';
Badge.displayName = 'ToolHeader.Badge';

/**
 * @deprecated This `ToolHeader` component is no longer supported and it is now recommended
 * to use the layout `ToolLandingPage`, `ToolLandingPage.Title` (for the settings button),
 * `ToolLandingPage.Tabs`, or based on content a `DetailPage`.
 *
 * @deprecatedSince 12.9.0
 *
 * @see https://stories.core.procore.com/?path=/story/core-react_demos-toollandingpage--demo
 */
export var ToolHeader = addSubcomponents({
  Icon: Icon,
  Title: Title,
  Tabs: Tabs,
  Actions: Actions,
  Badge: Badge,
  SettingsAction: SettingsAction
}, ToolHeader_);
//# sourceMappingURL=ToolHeader.js.map