import React from 'react';
import type { ToolLandingPageHeaderTemplateProps } from './ToolLandingPageTemplate.types';
export declare const ToolLandingPageHeaderTemplate: React.ForwardRefExoticComponent<Required<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "heading">> & Partial<Pick<import("../PageTemplate/PageHeaderTemplate").PageHeaderTemplateProps, "banner" | "pills" | "actions" | "subheading" | "tabs">> & {
    settingsLink?: string | React.FunctionComponent<import("../Button/Button.types").AsLinkProps> | React.ForwardRefExoticComponent<import("../Button/Button.types").AsLinkProps> | undefined;
} & React.RefAttributes<HTMLDivElement>>;
export declare const ToolLandingPageTemplate: React.ForwardRefExoticComponent<Pick<import("../PageTemplate/PageTemplate").PageTemplateProps, "children" | "header" | "pane"> & {
    headerProps?: ToolLandingPageHeaderTemplateProps | undefined;
} & React.RefAttributes<HTMLDivElement>>;
