/// <reference types="react" />
export declare type TypeaheadChangeEvent = React.ChangeEvent<HTMLInputElement> | React.MouseEvent<HTMLElement> | React.KeyboardEvent<HTMLInputElement>;
export declare type TypeaheadInputProps = Omit<React.ComponentPropsWithoutRef<'input'>, 'onChange'>;
export interface TypeaheadProps {
    /**
     * @since 10.19.0
     */
    ['data-qa']?: string;
    /**
     * @since 10.19.0
     */
    onChange?: (value: string, event: TypeaheadChangeEvent) => void;
}
