import type { FlattenSimpleInterpolation } from 'styled-components';
import type { Intent, TypographyProps, Weight } from './Typography.types';
export interface StyledTypographyProps {
    $breakWord?: TypographyProps['intent'];
    $color?: TypographyProps['color'];
    $intent?: TypographyProps['intent'];
    $italic?: TypographyProps['italic'];
    $weight?: TypographyProps['weight'];
}
export declare const typographyWeights: {
    [key in Weight]: number;
};
export declare const typographyLineHeight: Record<Intent, number>;
export declare function getTypographyIntent(intent: Intent): FlattenSimpleInterpolation;
export declare const semiboldRules: () => FlattenSimpleInterpolation;
export declare const StyledTypography: import("styled-components").StyledComponent<"span", any, StyledTypographyProps, never>;
