import type { Locale } from './I18n';
/**
 * @deprecated you can use OVERWRITE_LOCALE_MAP from [Globalization toolkit](https://github.com/procore/globalization-toolkit)
 * @deprecatedSince 12.10.0
 */
export declare const OVERWRITE_LOCALE_MAP: Record<string, Locale>;
/**
 * @deprecatedSince 12.10.0
 * @deprecated you can use getOverrideLocale from [Globalization toolkit](https://procore.github.io/globalization-toolkit/#md:getoverridelocale-function)
 * Returns the locale that should be used for the I18nProvider based on the environment locale
 * @param envLocale - the locale from the environment
 * @returns the locale that should be used for the I18nProvider
 */
export declare function getI18nProviderLocale(envLocale: string): Locale;
