import { css } from 'styled-components';
import { colors } from './colors';
export function arrowUp(size, color) {
  return css(["border-bottom:", "px solid ", ";border-left:", "px solid transparent;border-right:", "px solid transparent;border-top:0;"], size, colors[color], size, size);
}
export function arrowDown(size, color) {
  return css(["border-bottom:0;border-left:", "px solid transparent;border-right:", "px solid transparent;border-top:", "px solid ", ";"], size, size, size, colors[color]);
}
export function arrowRight(size, color) {
  return css(["border-bottom:", "px solid transparent;border-left:", "px solid ", ";border-right:0;border-top:", "px solid transparent;"], size, size, colors[color], size);
}
export function arrowLeft(size, color) {
  return css(["border-bottom:", "px solid transparent;border-left:0;border-right:", "px solid ", ";border-top:", "px solid transparent;"], size, size, colors[color], size);
}
//# sourceMappingURL=arrows.js.map