function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var luminosities = [10, 15, 20, 30, 40, 45, 50, 60, 70, 85, 90, 94, 96, 98];

// Palette Generation

function colorGenerator(color, hue, saturation) {
  var colorSet = {};
  for (var index in luminosities) {
    var key = "".concat(color).concat(luminosities[index]);
    colorSet[key] = "hsl(".concat(hue, ", ").concat(saturation, "%, ").concat(luminosities[index], "%)");
  }
  return colorSet;
}
function paletteGenerator() {
  return _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, colorGenerator('blue', 218, 75)), colorGenerator('cyan', 170, 65)), colorGenerator('gray', 200, 8)), colorGenerator('green', 125, 50)), colorGenerator('magenta', 310, 60)), colorGenerator('orange', 19, 100)), colorGenerator('purple', 288, 43)), colorGenerator('red', 360, 70)), colorGenerator('yellow', 45, 85)), {}, {
    black: 'black',
    white: 'white'
  });
}
export var colors = paletteGenerator();
//# sourceMappingURL=colors.js.map