export declare type Spacing = keyof typeof spacing;
/** Number values for padding, margin, etc.
 * Intended to be used as pixels.

  none: 0,

  xxs: 2,

  xs: 4,

  sm: 8,

  md: 12,

  lg: 16,

  xl: 24,

  xxl: 32,
 */
export declare const spacing: {
    /** value 0 */
    none: number;
    /** value 2 */
    xxs: number;
    /** value 4 */
    xs: number;
    /** value 8 */
    sm: number;
    /** value 12 */
    md: number;
    /** value 16 */
    lg: number;
    /** value 24 */
    xl: number;
    /** value 32 */
    xxl: number;
};
