import type React from 'react';
declare type RefCallback<T> = (newValue: T | null) => void;
declare type RefObject<T> = React.MutableRefObject<T | null>;
declare type ReactRef<T> = RefCallback<T> | RefObject<T> | null;
export declare function assignRef<T>(ref: ReactRef<T>, value: T | null): void;
export declare function mergeRefs<T>(...refs: ReactRef<T>[]): RefCallback<T>;
export {};
