import React from 'react';
import type { DivAttributes } from './types';
declare type Ref = React.ForwardedRef<HTMLDivElement>;
declare type Slots = Record<string, {
    slotChildren: React.ReactNode | null;
    slotProps: DivAttributes;
    slotRef: Ref | null;
}>;
declare type ReactComponent = React.FC | React.Component | React.ForwardRefExoticComponent<HTMLDivElement>;
export declare const slotify: (rawChildren: React.ReactNode, slotMap: Record<string, ReactComponent>) => Slots;
export {};
